/*
 * Commonly used data structure for the project
 *
 * Created by Dr. Xin Yuan for project I in the
 * Computer Networks class (cis49306).
 * Modify on your own risk. 
 */

#define MAX_PKT 10
typedef enum {data,ack,nak} frame_kind;
typedef struct {unsigned char data[MAX_PKT];int size;} packet;
typedef unsigned int seq_nr;

typedef struct {
  frame_kind kind;
  seq_nr seq;
  seq_nr ack;
  packet info;
  int checksum;
} frame;

#define SENDER 0
#define RECEIVER 1
 
#define NOFRAME 0
#define FRAME 1

/* variables for statistics */


extern int packet_sent;
extern int packet_received;
extern int frame_sent;
extern int frame_received;
extern int data_frame_sent;
extern int data_frame_received;
extern int ack_frame_sent;
extern int ack_frame_received;
extern int nack_frame_sent;
extern int nack_frame_received;
extern int frame_lost_congestion;
extern int frame_lost_link;
extern int frame_lost_error;

/* user routines */

extern void initialize_sender();
extern void initialize_receiver();
extern void from_network_layer(packet *p);
extern void to_network_layer(packet *p);
extern void to_physical_layer(frame *f);
extern int from_physical_layer(frame *f, int tout);

extern void print_statistics();













