/*
 * Utility routines.
 * You are NOT supposed to change this file.
 *
 * Created by Dr. Xin Yuan for project I in the Computer Networks
 * class (cis49306).
 */

#include <stdio.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/time.h>
#include <netdb.h>

#include "sockets.h"
#include "common.h"

int send_sock;  /* socket used for sending */
int rec_sock;   /* socket used for receiving */
FILE *rfd;
FILE *wfd;

frame EOFframe;
#define isEOFframe(x) ((x).info.data[0] == 0x01)

/* variables for statistics */


int packet_sent;
int packet_received;
int frame_sent;
int frame_received;
int data_frame_sent;
int data_frame_received;
int ack_frame_sent;
int ack_frame_received;
int nack_frame_sent;
int nack_frame_received;
int frame_lost_congestion;
int frame_lost_link;
int frame_lost_error;

/* error parameter */

int link_error_rate;
int transmission_error_rate;

void print_statistics();

/* post the ip address + port number --> xxx.xxx.xxx.xxx #### */

static void post_ip_address(struct sockaddr_in *addr)
{
  union {
    struct in_addr addr;
    unsigned char    byte[4];
  } address;

  int port;

  port = addr->sin_port;  /* assign port number */
  address.addr = addr->sin_addr; /* assign the address */

  printf("%d.%d.%d.%d   %d\n", address.byte[0],
         address.byte[1], address.byte[2], address.byte[3], port);
}


/* post only the ip address */

static void post_ip_address_short(struct sockaddr_in *addr)
{
  union {
    struct in_addr addr;
    unsigned char    byte[4];
  } address;

  int port;

  port = addr->sin_port;  /* assign port number */
  address.addr = addr->sin_addr; /* assign the address */

  printf("%d.%d.%d.%d", address.byte[0],
         address.byte[1], address.byte[2], address.byte[3]);
}

/* this routine establish two tcp connections: sender <--> receiver */


void initialize_sender()
{
  int acc_sock;
  int port = 0;
  union {
    struct in_addr inaddr;
    unsigned char naddr[4];
  } myaddr;
  char myname[50];           /* my internet name */
  struct hostent *   hp;

  char receiver_address[50]; /* where is the receiver?? */
  int receiver_port;         /* which port is he using? */

  struct sockaddr_in  addr;
  int                 len = sizeof(addr);

  /* prepare the file */

  if ((rfd = fopen("INPUTFILE012", "r")) == NULL) {
    printf("Can't open file INPUTFILE012 to read.\n");
    exit(0);
  }

  /* initializing the network */

  acc_sock = open_bound_tcp_socket(&port);
  listen(acc_sock, 5);

  gethostname(myname, sizeof(myname));

  if ((hp = gethostbyname(myname)) == 0) {
    printf("Sockets: can't get my host name\n");
    exit(1);
  }

  bcopy(hp->h_addr, &(myaddr), hp->h_length);
  
  printf("Sender address : %d.%d.%d.%d  %d\n", myaddr.naddr[0],
         myaddr.naddr[1], myaddr.naddr[2], myaddr.naddr[3], port);

  /*
  if (getsockname(acc_sock, (struct sockaddr *)&addr, &len) < 0)
  {
    perror(": can't get name");
    close(acc_sock);
    exit(1);
  }
  */
  
  /* post the address */
  /*
  printf("Sender address : ");
  post_ip_address(&addr);
  */
  /* connecting the receiver */

  printf("Establishing data channel (input receiver address)....\n");
  printf("Receiver adderss : ");
  scanf("%s %d", receiver_address, &receiver_port); getchar();

  send_sock = tcp_connect(receiver_address, receiver_port);
  printf("Data channel established....\n");

  printf("Waiting for receiver to establish ack channel...\n");
  rec_sock = accept(acc_sock, (struct sockaddr *)&addr, &len);

  if (rec_sock < 0) {
    perror(": accept");
    exit(1);
  }
  printf("Ack channel from "); post_ip_address_short(&addr); 
  printf("  established.\n");  

  /* end of the network initilization */

  /* initialing statistics variables */

  packet_sent = 0;
  packet_received = 0;
  frame_sent = 0;
  frame_received = 0;
  data_frame_sent = 0;
  data_frame_received = 0;
  ack_frame_sent = 0;
  ack_frame_received = 0;
  nack_frame_sent = 0;
  nack_frame_received = 0;
  frame_lost_congestion = 0;
  frame_lost_link = 0;
  frame_lost_error = 0;

  /* read in the error parameters */

  printf("Input link error percentage (0-99) : ");
  scanf("%d", &link_error_rate); getchar();
  printf("Input transmission error percentage (0-99) : ");
  scanf("%d", &transmission_error_rate); getchar();
}

/* initialize the receiver */

void initialize_receiver()
{
  int acc_sock;
  int port = 0;
  union {
    struct in_addr inaddr;
    unsigned char naddr[4];
  } myaddr;
  char myname[50];           /* my internet name */
  struct hostent *   hp;
  char sender_address[50]; /* where is the sender */
  int sender_port;         /* which port is he using? */

  struct sockaddr_in  addr;
  int                 len = sizeof(addr);

  /* prepare the file */

  if ((wfd = fopen("OUTPUTFILE012", "w")) == NULL) {
    printf("Can't open file OUTPUTFILE012 to write.\n");
    exit(0);
  }

  /* now the network */ 

  acc_sock = open_bound_tcp_socket(&port);
  listen(acc_sock, 5);

  gethostname(myname, sizeof(myname));

  if ((hp = gethostbyname(myname)) == 0) {
    printf("Sockets: can't get my host name\n");
    exit(1);
  }

  bcopy(hp->h_addr, &(myaddr), hp->h_length);
  
  printf("Receiver address : %d.%d.%d.%d  %d\n", myaddr.naddr[0],
         myaddr.naddr[1], myaddr.naddr[2], myaddr.naddr[3], port);

  printf("Waiting for sender to establishing data channel...\n");
  rec_sock = accept(acc_sock, (struct sockaddr *)&addr, &len);

  if (rec_sock < 0) {
    perror(": accept");
    exit(1);
  }
  printf("Data channel from "); post_ip_address_short(&addr); 
  printf("  established.\n");  
  
  /* connecting the receiver */

  printf("Establishing ack channel (input sender address)....\n");
  printf("Sender adderss : ");
  scanf("%s %d", sender_address, &sender_port); getchar();

  send_sock = tcp_connect(sender_address, sender_port);
  printf("Ack channel established....\n");

  /* initialize the statics variables */

  packet_sent = 0;
  packet_received = 0;
  frame_sent = 0;
  frame_received = 0;
  data_frame_sent = 0;
  data_frame_received = 0;
  ack_frame_sent = 0;
  ack_frame_received = 0;
  nack_frame_sent = 0;
  nack_frame_received = 0;
  frame_lost_congestion = 0;
  frame_lost_link = 0;
  frame_lost_error = 0;

  /* read in the error parameters */

  printf("Input link error percentage (0-99) : ");
  scanf("%d", &link_error_rate); getchar();
  printf("Input transmission error percentage (0-99) : ");
  scanf("%d", &transmission_error_rate); getchar();

}

void from_network_layer(packet *p)
{
  int i;
  if (feof(rfd)) {
    /* sender dies here */
    fclose(rfd);
    EOFframe.info.data[0] = 0x01;
    Tcp_write(send_sock, &EOFframe);
    /* need to send two, one might lost */
    printf("Sender "); print_statistics();
    exit(0);
  }
  while ((!feof(rfd)) && (!(p->size = fread(p->data,sizeof(char), rand() % 9 + 1, rfd))));

  if (feof(rfd)) {
        fclose(rfd);
    EOFframe.info.data[0] = 0x01;
    Tcp_write(send_sock, &EOFframe);
    /* need to send two, one might lost */
    printf("Sender "); print_statistics();
    exit(0);
  }
  
  packet_sent++;
}

void to_network_layer(packet *p)
{
  /*
  if (p->data[0] == 0x01) {
    printf("Receiver ");
    print_statistics();
    fclose(wfd);
    exit(0);
  }
  */
  fwrite(p->data, sizeof(char), p->size, wfd);
  packet_received++;  
}

/* nothing here, but the receiving end is much worse */

void to_physical_layer(frame *f)
{
  fd_set rdset, wdset, edset;
  int ret;

  FD_ZERO(&rdset);
  FD_ZERO(&wdset);
  FD_ZERO(&edset);
  FD_SET(send_sock, &wdset);
  FD_SET(send_sock, &edset);

  /* block it */
  
  ret = select(64, &rdset, &wdset, &edset, NULL);

  if ((ret == -1) || (ret == 0)) {
    printf("No, not here.\n");
  }

  Tcp_write(send_sock, f);
}

/* 
   faking a lot of bad things.
   link error, resulting the data link layer not receiving any thing
   transmission error resulting the data link layer receiving wrong
   too congest, lost packet. -- emulating a real link
 
   return value : NOTHING, WRONGFRAME, CORRECTFRAME
   timeout in terms of seconds
*/

int from_physical_layer(frame *f, int tout)
{
  struct timeval timeout;
  int ret;
  int random_num;
  frame drop;

  fd_set rdset, wdset, edset;

  timeout.tv_sec = 0;
  timeout.tv_usec = tout;
 
  FD_ZERO(&rdset);
  FD_ZERO(&edset);    
  FD_ZERO(&wdset);    

  FD_SET(rec_sock, &rdset);
  FD_SET(rec_sock, &edset);

  ret = select(64, &rdset, &wdset, &edset, &timeout);
  if (ret == -1) {
    printf("Something wrong.\n");
    exit(0);
  }

  if (ret == 0) return NOFRAME;

  if (FD_ISSET(rec_sock, &rdset)) {
    /* read one frame out */
    Tcp_read(rec_sock, f);

    if (isEOFframe(*f)) {
      print_statistics();    fclose(wfd);
      exit(0);
    }

    /* faking link error here */

    if ((!isEOFframe(*f)) && 
        ((random_num = rand() % 100) < link_error_rate)) {
      /* link error occurs */
      frame_lost_link ++;
      return NOFRAME;
    }

    if ((!isEOFframe(*f)) && 
        ((random_num = rand() % 100) < transmission_error_rate)) {
      /* return error frame */
      if (rand() % 3 == 0) {
        f->checksum += 1;
        f->seq +=10;f->ack += 10;
      } else {
        int i = 0;
        f->seq +=10;f->ack += 10;
        f->info.data[i] = 'e';
      }
      return FRAME;
    }
    return FRAME;
  }
  return NOFRAME;
}

